Description

Adding an override to a smart class parameter of type YAML with the value:

test:

example: hello

results in the host edit form showing the parameter as: --- ! "test: \nexample: hello\n"

Related issues:

Related to Foreman - Tracker #4470: Usability of parameters and overrides New

Related to Foreman - Bug #11782: Puppet override with invalid hash array does... Closed 09/11/2015

Related to Foreman - Bug #12095: Smart Class Parameters mangle erb interpolat... Closed 10/07/2015

Related to Foreman - Bug #12284: host group parameter overrides reformatting ... New 10/23/2015

Has duplicate Foreman - Bug #11830: Different results when adding a parameter... Duplicate 09/15/2015

Has duplicate Foreman - Bug #11962: Override of Host-Parameter is saved malfo... Duplicate 09/25/2015

Has duplicate Foreman - Bug #12191: Array-typed smart parameters changed to b... Duplicate 10/15/2015

Has duplicate Foreman - Bug #12324: Hash and array smart parameters are getti... Duplicate 10/27/2015

Associated revisions

Revision 00335956 - 10/01/2015 11:25 AM - Dominic Cleal

fixes #11375, #11782 - validate a host's lookup_values

Enabling validation ensures the casting and validation within

LookupValue runs during host/hostgroup save.  Tweaks to hostgroup

cloning ensure that the newly cloned hostgroup now passes validation

when it has associated lookup values.

Don't show any LookupValue#match errors in the host/hostgroup forms

as the value is autogenerated by the nested attribute setter.

Revision e476ae3a - 10/30/2015 01:33 PM - Dominic Cleal

fixes #11375, #11782 - validate a host's lookup_values

Enabling validation ensures the casting and validation within

LookupValue runs during host/hostgroup save.  Tweaks to hostgroup

cloning ensure that the newly cloned hostgroup now passes validation

when it has associated lookup values.

Don't show any LookupValue#match errors in the host/hostgroup forms

as the value is autogenerated by the nested attribute setter.

(cherry picked from commit 003359564b4ab5fa8198cc9b035df405e7e600cd)

History

#1 - 08/16/2015 08:29 AM - Ori Rabin
- Related to Tracker #4470: Usability of parameters and overrides added

#2 - 08/17/2015 03:29 AM - Dominic Cleal

- Category set to Parameters

#3 - 09/23/2015 03:09 AM - Dominic Cleal

- translation missing: en.field_release set to 91

#4 - 09/23/2015 03:09 AM - Dominic Cleal

- Has duplicate Bug #11830: Different results when adding a parameter override from a hostgroup vs puppet class directly added

#5 - 09/23/2015 03:57 AM - Dominic Cleal

This seems to be because of the :validate => false on the association in host_common to lookup_value.  The validation's necessary to cast the value

correctly - and also to fix issues such as #11782.

#6 - 09/23/2015 03:57 AM - Dominic Cleal

- Related to Bug #11782: Puppet override with invalid hash array doesn't give error added

#7 - 09/23/2015 05:09 AM - Dominic Cleal

- Status changed from New to Assigned

- Assignee set to Dominic Cleal

- translation missing: en.field_release deleted (91)

#8 - 09/23/2015 06:15 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2755 added

- Pull request deleted ()

#9 - 09/25/2015 03:16 AM - Dominic Cleal

- Has duplicate Bug #11962: Override of Host-Parameter is saved malformed added

#10 - 10/01/2015 10:46 AM - Julien Pivotto

Why did you delete Release  (1.9.3)? this is a very annoying bug and the PR has lots of conflicts with 1.9 branch so it would be great to see this

backported properly in 1.9. Thanks :)

#11 - 10/01/2015 10:55 AM - Julien Pivotto

The blocking problem is that each time you save the host (e.g change anything on the host and click save) the smart parameters are malformed

#12 - 10/01/2015 12:02 PM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 003359564b4ab5fa8198cc9b035df405e7e600cd.

#13 - 10/06/2015 03:42 AM - Dominic Cleal

- translation missing: en.field_release set to 63

#14 - 10/06/2015 04:04 AM - Dominic Cleal

Julien Pivotto wrote:

Why did you delete Release  (1.9.3)?

 I mistakenly thought it was a new, 1.9 regression, but it wasn't.

this is a very annoying bug and the PR has lots of conflicts with 1.9 branch so it would be great to see this backported properly in 1.9. Thanks :)

 Yeah, I will investigate this but at the moment I don't have the time to make sure it works properly.  The implementation of overrides between 1.10
and 1.9 is different in a few places, so I'm not sure if the fix will introduce further bugs in 1.9 - it's going to need some testing.  For now I'm placing it

on 1.10.

#15 - 10/09/2015 08:07 AM - Dominic Cleal

- Related to Bug #12095: Smart Class Parameters mangle erb interpolated variables added

#16 - 10/12/2015 03:03 AM - Anthony Lapenna

+1 really annoying bug, would be nice if the fix could be release in 1.9.

#17 - 10/14/2015 04:30 AM - Vladimir Stackov

+1 for 1.9 backport.

#18 - 10/14/2015 05:04 AM - Dominic Cleal

- translation missing: en.field_release changed from 63 to 91

No promises, but I'll move it to make sure it appears on the right TODO list.  Hopefully the backport's possible.

#19 - 10/15/2015 06:58 PM - Anonymous

- Has duplicate Bug #12191: Array-typed smart parameters changed to broken JSON added

#20 - 10/21/2015 05:30 AM - Julien Pivotto

The problem is the same for hostgroups. You can not save hostgroup without breaking the smart variables.

#21 - 10/22/2015 03:14 PM - larry campbell

Is this fix found in 1.10.0-RC1?

#22 - 10/23/2015 03:05 AM - Dominic Cleal

larry campbell wrote:

Is this fix found in 1.10.0-RC1?

 Yes.

#23 - 10/23/2015 09:55 AM - Dominic Cleal

- Related to Bug #12284: host group parameter overrides reformatting YAML values to strings added

#24 - 10/27/2015 07:11 AM - Anthony Lapenna

- File deep_merge_exception.txt added

Btw, once your parameters are 'corrupted' you'll not be able to edit your host or even access the YML dump.

See the attached file for more details about the stacktrace.

#25 - 10/27/2015 09:09 AM - Dominic Cleal

- Has duplicate Bug #12324: Hash and array smart parameters are getting corrupted after multiple saves added

#26 - 10/29/2015 02:00 PM - Anonymous

Dominic Cleal wrote:

No promises, but I'll move it to make sure it appears on the right TODO list.  Hopefully the backport's possible.

 Will this make it to 1.9.3?

#27 - 10/30/2015 08:38 AM - Dominic Cleal

Alyssa H wrote:

Will this make it to 1.9.3?
 Yep, seems to be working fine!  I hope to get .3 out early next week as we've got pretty much everything I hoped for.

#28 - 11/03/2015 12:11 PM - Vladimir Stackov

Hallelujah! Thanks Dominic!

#29 - 11/04/2015 01:00 PM - Tim Verhoeven

I've just upgrade my 1.9.2 install to 1.9.3. But it seems that the issue isn't fixed in 1.9.3. I'm still having the issue. Could somebody else test and

verify?

#30 - 11/04/2015 01:08 PM - Anthony Lapenna

We're still having this issue but with array type parameters only.

#31 - 11/04/2015 03:23 PM - Brad Cowie

It seems like 1.9.3 fixed it for me when using arrays on the host/group override page.

I did initially have trouble updating overrides that had previously been escaped and stored in the db. Try fixing your overrides manually in the puppet

classes page and then when the correct unescaped version of the override is stored in the db try again from the host/group override page.

#32 - 01/12/2016 07:48 AM - Vincent Miszczak

I still have the issue in 1.10 for a host belonging to a nested group.

Group have original multi line yaml->NestedGroup inherits->Host inherits->broken yaml

#33 - 05/26/2016 01:29 AM - Ben Bettridge

This also impacts me on 1.11.1.

Files

deep_merge_exception.txt 24.3 KB 10/27/2015 Anthony Lapenna
